/*
 * bmp-itouch - Multimedia keyboard control plugin for BMP
 * Copyright (C) 2000-2005 Ville Syrjl <syrjala@sci.fi>
 *                         Bryn Davies <curious@ihug.com.au>
 *                         Jonathan A. Davis <davis@jdhouse.org>
 *                         Jeremy Tan <jeremytan@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include "keygrab.h"
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <string.h>

int grab_key(KeyCode code, Display *display, Window root)
{
	//KeySym sym;
	//gint i;
	
	/* if there is a value in keystring, get its KeySym and convert to
	   keycode */
	/*if (keystring != NULL) {
		if ((sym = XStringToKeysym(keystring)) == NoSymbol)
			return -1;
		/* converting KeySym to KeyCode */
	/*	if ((code = XKeysymToKeycode(GDK_DISPLAY(), sym)) == 0)
		return -1;
	}
	*/

	gdk_error_trap_push();
	gdk_flush();
	
	XGrabKey(display, code, AnyModifier, root,
				FALSE, GrabModeAsync, GrabModeAsync);
				
	if (gdk_error_trap_pop()) {
		return -1;
	}
	
	return 0;
}

int ungrab_key(KeyCode code, Display *display, Window root)
{
	gdk_error_trap_push();
	gdk_flush();

	XUngrabKey(display, code, AnyModifier, root);

	if (gdk_error_trap_pop()) {
		return -1;
	}
	
	return 0;

}

KeyCode gnome_key_config(char *keystring)
{
	KeySym sym;
	KeyCode code;
	gint i;

	if ((sym = XStringToKeysym(keystring)) == NoSymbol)
		return 0;
	if ((code = XKeysymToKeycode(GDK_DISPLAY(), sym)) == 0)
		return 0;

	return code;
}



